Implementation of HIntS

# Installation creating conda environment 
conda create -n obj python=3.8
conda activate obj
# Installing Robosuite with pushing domain (from source)
git clone https://github.com/ARISE-Initiative/robosuite.git
conda activate obj
cd robosuite
copy mujoco download to: ~/.mujoco/mujoco200
copy mujoco key to ~/.mujoco/mjkey.txt
pip install -r requirements.txt
https://robosuite.ai/docs/installation.html
# install remaining components
conda install pytorch torchvision torchaudio cudatoolkit=10.2 -c pytorch
conda install pytorch torchvision torchaudio pytorch-cuda=11.7 -c pytorch -c nvidia
pip install tianshou / pip install git+https://github.com/thu-ml/tianshou.git@master --upgrade
conda install imageio
pip install opencv-python
conda install psutil
pip install pyyaml

# installing for HYPE
follow above install
conda install -c anaconda scikit-learn
pip -U install cma

# installing for cdl
conda install pytorch=1.11=py3.8_cuda10.2_cudnn7.6.5_0 torchvision torchaudio cudatoolkit=10.2 -c pytorch
conda install -c conda-forge tensorboard
conda install -c anaconda scikit-image
conda install -c conda-forge matplotlib
git clone https://github.com/ARISE-Initiative/robosuite.git
cd robosuite
pip install -r requirements.txt
conda install -c conda-forge gym
pip install opencv-python
conda install -c anaconda seaborn

# Run Breakout Training:
python generate_random.py --env Breakout --record-rollouts /hdd/datasets/object_data/breakout/random/ --variant drop_stopping
python main.py --main-train BreakoutStack
python main.py --main-train BreakoutVariants

# Run Robopushing training:
python generate_random.py --env RoboPushing --record-rollouts /hdd/datasets/object_data/robopushing/testrun/random --num-frames 5000
python main.py --main-train RoboPushingStack
python main.py --main-train RoboPushingObstacle
